package ThoMath::Formula;

use Math::Trig;


sub new
{
	my $class = shift;
	my $self = {};
	bless $self, $class;
	$self->{formula} = shift;
	$self->{transformula} = undef;
	$self->{const} = shift;
	$self->{undef_consts} = {};
	$self->{vars} = [];
	$self->transform();
	return $self;
}


sub evaluate
{
#	my $self = shift;
#	my $var = shift;
#	my $const = $self->{const};
#	return $#{$var} >= $#{$self->{vars}} ? eval($self->{transformula}) : undef;
	print STDERR "Dummy evaluate...\n";
	return undef;
}

# a variable is any lowercase character sequence not followed by (
# a constant is any Uppercase character sequence not followed by (
sub transform
{
	my $self = shift;
	
	my $formula = $self->{formula}; #need a copy here
	$self->{transformula} = 'sub evaluate {'."\n".'my $self = shift; my $var = shift;	my $const = $self->{const}; return $#{$var} >= $#{$self->{vars}} ? ('."\n";

	my %vh = (); #only intermediate for remembering the indices
	$self->{vars} = (); #storing the names here, of course
	my %ch = (); #intermediate...
	$self->{undef_consts} = []; #you know the trick;-)

	#blast... I could look for non-[ in the previous case
	#here I may have functions with names...
	#we have: lowercase (vars), uppercase (const), operators, whitespace, low/up(.*) (functions)
	#OK, then... look for any letter sequence with its following character with the regex and _then_ discriminate
	
	while($formula =~ /^([^a-zA-Z_]*)([a-zA-Z_]+)(([^a-zA-Z_])(.*)|)$/) #is this ordered? I won't rely on this assumption
	{
		#watch out: $1 is foreword
		# $2 is the character sequence
		# $3 is the whole stuff after that (may be nothing)
		# $4 is the follower is existing
		# $5 is the rest if existing 
		#so, if the stuff after is empty, I don't care - I need 4 and 5 (which both may be empty)

		$self->{transformula} .= $1;
		my $chars = $2;
		my $follower = $4;
		my $rest = $5;
		my $stuff = $3;
		if(defined $follower and ($follower eq '(' or $follower =~ /\d/)) #a function or part of function name (e.g deg2rad!)
		{
			$self->{transformula} .= $chars.$follower;
			$formula = $rest;
		}
		else #variable/constant
		{
			#now, see which kind we have
			if( $chars =~ /^[a-z_]+$/ )
			{
				unless(defined $vh{$chars}){ push(@vars, $chars); $vh{$chars} = $#vars; }
				$self->{transformula} .= ' $var->['.$vh{$chars}.'] ';
			}
			else #must be constant
			{
				$self->{transformula} .= ' $const->{'.$chars.'} ';
				unless(defined $self->{const}->{$chars}){ ++$ch{$chars};}
			}
			$formula = $stuff;
		}
		#print $formula,"..",$self->{transformula},"\n";

	}

	$self->{transformula} .= $formula.') : undef; }';

	$self->{undef_consts} = [keys %ch];
	$self->{vars} = [keys %vh];
	
	my $wset = $^W;
	$^W = 0;
	eval($self->{transformula});
	$^W = $wset;

}


1;
